<?xml version="1.0" encoding='koi8-r'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:exsl="http://exslt.org/common">
<!--    -->
<xsl:import href="http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"/>


<xsl:import href="./titles.xsl"/>
<xsl:import href="./tables.xsl"/>
<xsl:import href="./colontitles.xsl"/>
<xsl:import href="./pagesetup.xsl"/>
<!--      -->
<xsl:import href="../common/collect_authors.xsl"/>

<!--      -->
<xsl:param name="page.margin.inner" select="'25mm'"/>
<xsl:param name="page.margin.outer" select="'10mm'"/>
<xsl:param name="body.margin.bottom" select="'-13mm'"/>
<xsl:param name="body.margin.top" select="'-2mm'"/>
<xsl:param name="paper.type" select="'A5'"/>

<!--    -->
<xsl:param name="double.sided" select="'1'"/>

<!--    -->
<xsl:param name="toc.section.depth">3</xsl:param>
<xsl:param name="toc.indent.width" select="12"/> 

<!--     -->
<!--<xsl:param name="variablelist.as.blocks" select="'1'"/>-->
<xsl:param name="glosslist.as.blocks" select="'1'"/>

<xsl:param name="header.rule" select="'0'"/>

<xsl:param name="title.margin.left">0mm</xsl:param>

<!--      -->
<xsl:param name="local.l10n.xml" select="document('../common/ru.xml')"/>

<xsl:param name="use.role.as.xrefstyle" select="0"/>

<!--      -->

<xsl:param name="title.font.family" select="'serif'"/>

<xsl:attribute-set name="normal.para.spacing">
  <xsl:attribute name="space-before.optimum">0em</xsl:attribute>
  <xsl:attribute name="space-before.minimum">0em</xsl:attribute>
  <xsl:attribute name="space-before.maximum">0.2em</xsl:attribute>
  <xsl:attribute name="text-indent">0.8em</xsl:attribute>
</xsl:attribute-set>  

<xsl:attribute-set name="list.block.spacing">
  <xsl:attribute name="space-before.optimum">0.5em</xsl:attribute>
  <xsl:attribute name="space-before.minimum">0.4em</xsl:attribute>
  <xsl:attribute name="space-before.maximum">0.6em</xsl:attribute>
  <xsl:attribute name="space-after.optimum">0.9em</xsl:attribute>
  <xsl:attribute name="space-after.minimum">0.8em</xsl:attribute>
  <xsl:attribute name="space-after.maximum">0.7em</xsl:attribute>
</xsl:attribute-set>
<xsl:attribute-set name="list.item.spacing">
  <xsl:attribute name="space-before.optimum">0.2em</xsl:attribute>
  <xsl:attribute name="space-before.minimum">0.1em</xsl:attribute>
  <xsl:attribute name="space-before.maximum">0.3em</xsl:attribute>
</xsl:attribute-set>


<xsl:attribute-set name="table.cell.padding">
  <xsl:attribute name="padding">2pt</xsl:attribute>
</xsl:attribute-set>



<xsl:attribute-set name="section.title.properties">
  <xsl:attribute name="font-family">
    <xsl:value-of select="$title.font.family"/>
  </xsl:attribute>
  <xsl:attribute name="font-weight">bold</xsl:attribute>
  <!-- font size is calculated dynamically by section.heading template -->
  <xsl:attribute name="text-align">left</xsl:attribute>
  <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
  <xsl:attribute name="space-before.minimum">0.8em</xsl:attribute>
  <xsl:attribute name="space-before.optimum">1.0em</xsl:attribute>
  <xsl:attribute name="space-before.maximum">1.2em</xsl:attribute>
  <xsl:attribute name="space-after.minimum">0.3em</xsl:attribute>
  <xsl:attribute name="space-after.optimum">0.4em</xsl:attribute>
  <xsl:attribute name="space-after.maximum">0.5em</xsl:attribute>
<!--  <xsl:attribute name="text-indent">1em</xsl:attribute> -->
</xsl:attribute-set>


<xsl:attribute-set name="formal.title.properties" use-attribute-sets="normal.para.spacing">
  <xsl:attribute name="text-indent">0pt</xsl:attribute>
  <xsl:attribute name="font-weight">normal</xsl:attribute>
  <xsl:attribute name="font-size">10pt</xsl:attribute> 
  <xsl:attribute name="hyphenate">false</xsl:attribute>
  <xsl:attribute name="space-after.minimum">0.2em</xsl:attribute>
  <xsl:attribute name="space-after.optimum">0.4em</xsl:attribute>
  <xsl:attribute name="space-after.maximum">0.6em</xsl:attribute>
</xsl:attribute-set>

<xsl:attribute-set name="formal.object.properties">
  <xsl:attribute name="space-before.minimum">0.2em</xsl:attribute>
  <xsl:attribute name="space-before.optimum">0.4em</xsl:attribute>
  <xsl:attribute name="space-before.maximum">0.6em</xsl:attribute>
  <xsl:attribute name="space-after.minimum">0.2em</xsl:attribute>
  <xsl:attribute name="space-after.optimum">0.4em</xsl:attribute>
  <xsl:attribute name="space-after.maximum">0.6em</xsl:attribute>
</xsl:attribute-set>



<xsl:param name="formal.title.placement">
figure after
example before
equation before
table before
procedure before
</xsl:param>

<xsl:param name="menuchoice.menu.separator" select="'&#8594;'"/>
<xsl:param name="menuchoice.separator" select="'&#8594;'"/>

<xsl:template match="guimenu">&#x00AB;<xsl:call-template name="inline.charseq"/> &#x00BB;</xsl:template>

<xsl:template match="guimenuitem">&#x00AB;<xsl:call-template name="inline.charseq"/>&#x00BB;</xsl:template>

<xsl:template match="guisubmenu">&#x00AB;<xsl:call-template name="inline.charseq"/>&#x00BB;</xsl:template>

<xsl:template match="guilabel">&#x00AB;<xsl:call-template name="inline.charseq"/>&#x00BB;</xsl:template>

<xsl:template match="guibutton">&#x00AB;<xsl:call-template name="inline.charseq"/>&#x00BB;</xsl:template>

<xsl:template name="toc.line">
  <xsl:variable name="id">
     <xsl:call-template name="object.id"/>
  </xsl:variable>
	  
  <xsl:variable name="label">
     <xsl:apply-templates select="." mode="label.markup"/>
  </xsl:variable>

  <fo:block text-align-last="justify"
            end-indent="{$toc.indent.width}pt"
            last-line-end-indent="{$toc.indent.width}pt">
    <fo:inline>
      <fo:basic-link internal-destination="{$id}">
       <xsl:if test="$label != ''">
          <xsl:copy-of select="$label"/>
          <xsl:value-of select="$autotoc.label.separator"/>
       </xsl:if>
       <xsl:apply-templates select="." mode="title.markup"/>
      </fo:basic-link>
<!--    </fo:inline>
    <fo:inline keep-together.within-line="always"> -->
      <xsl:text>&#x00A0;</xsl:text>
      <fo:leader leader-pattern="dots"
                 leader-pattern-width="3pt"
                 leader-alignment="reference-area"
                 keep-with-next.within-line="always"/>
      <xsl:text>&#x00A0;</xsl:text>
      <fo:basic-link internal-destination="{$id}">
          <fo:page-number-citation ref-id="{$id}"/>
      </fo:basic-link>
   </fo:inline>
 </fo:block>
</xsl:template>
											       


<xsl:template name="nongraphical.admonition">
  <xsl:variable name="id">
    <xsl:call-template name="object.id"/>
  </xsl:variable>
  <fo:block space-before.minimum="0.4em"
            space-before.optimum="0.5em"
            space-before.maximum="0.6em"
	    space-after.minimum="0.3em"
            space-after.optimum="0.4em"
            space-after.maximum="0.5em"
            start-indent="0.12in"
            end-indent="0.12in"

	>
  <fo:block space-before.minimum="0.1em"
            space-before.optimum="0.15em"
            space-before.maximum="0.2em"
	    space-after.minimum="0.3em"
            space-after.optimum="0.4em"
            space-after.maximum="0.5em"
            start-indent="0.13in"
            end-indent="0.13in"
	    background-color="#e0e0e0"
	    padding="5pt" border-style="solid"	
            id="{$id}">
    <fo:block keep-with-next='always'
       	    space-before.optimum="-1.2em"
              xsl:use-attribute-sets="admonition.title.properties">
      <xsl:apply-templates select="." mode="object.title.markup"/>
    </fo:block>

    <fo:block xsl:use-attribute-sets="admonition.properties">
      <xsl:apply-templates/>
    </fo:block>
  </fo:block>
  </fo:block>
</xsl:template>


<!--<xsl:template name="process.menuchoice">
  <xsl:param name="nodelist" select="guibutton|guiicon|guilabel|guimenu|guimenuitem|guisubmenu|interface"/>
  <xsl:param name="count" select="1"/>
  <xsl:choose>
    <xsl:when test="$count>count($nodelist)"></xsl:when>
    <xsl:when test="$count=1">
      <xsl:apply-templates select="$nodelist[$count=position()]"/>
      <xsl:call-template name="process.menuchoice">
        <xsl:with-param name="nodelist" select="$nodelist"/>
        <xsl:with-param name="count" select="$count+1"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
      <xsl:variable name="node" select="$nodelist[$count=position()]"/>
      <xsl:choose>
        <xsl:when test="name($node)='guimenuitem'
                        or name($node)='guisubmenu'">
          <xsl:value-of select="$menuchoice.menu.separator"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$menuchoice.separator"/>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="$node"/>
      <xsl:call-template name="process.menuchoice">
        <xsl:with-param name="nodelist" select="$nodelist"/>
        <xsl:with-param name="count" select="$count+1"/>
      </xsl:call-template>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>-->


<!--  ulink      -->
<xsl:template match="ulink">
   <xsl:choose>
     <xsl:when test="string(.)=''">
       <fo:inline font-family="monospace"><xsl:value-of select="@url"/></fo:inline> 
     </xsl:when>
     <xsl:when test="(substring-after(.,':')=substring-after(@url,':') and 7>string-length(substring-before(.,':')) and string-length(@url)>0) or .=substring-after(@url,':')">
       <fo:inline font-family="monospace"><xsl:value-of select="."/></fo:inline>
     </xsl:when>
     <xsl:otherwise>
<fo:inline font-style="italic"><xsl:value-of select="."/></fo:inline><fo:footnote>
    <fo:inline font-style="normal">
          <xsl:call-template name="format.footnote.mark">
            <xsl:with-param name="mark">
              <xsl:apply-templates select="." mode="footnote.number"/>
            </xsl:with-param>
          </xsl:call-template>
        </fo:inline>
        <fo:footnote-body font-family="monospace" font-style="normal"
                          font-size="{$footnote.font.size}">
          <xsl:call-template name="format.footnote.mark">
            <xsl:with-param name="mark">
              <xsl:apply-templates select="." mode="footnote.number"/>
            </xsl:with-param>
          </xsl:call-template>
	  <xsl:variable name="url">
	     <xsl:choose>
               <xsl:when test="substring-before(@url,':')='mailto'">
		 <xsl:value-of select="substring-after(@url,':')"/></xsl:when>
               <xsl:otherwise><xsl:value-of select="@url"/></xsl:otherwise>
	     </xsl:choose>		
          </xsl:variable>
          <fo:inline font-family="monospace"><xsl:value-of select="$url"/></fo:inline>
        </fo:footnote-body></fo:footnote>
    </xsl:otherwise>
   </xsl:choose>
</xsl:template>

<!--        -->
<xsl:template match="footnote|ulink" mode="footnote.number">
  <xsl:choose>
    <xsl:when test="ancestor::tgroup">
      <xsl:number level="any" from="tgroup" format="a"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:variable name="pfoot" select="preceding::footnote|preceding::ulink"/>
      <xsl:variable name="ptfoot" select="preceding::tgroup//footnote"/>
      <xsl:number value="count($pfoot) - count($ptfoot) + 1" format="1"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template name="format.footnote.mark">
  <xsl:param name="mark" select="'?'"/>
  <fo:inline font-family="serif" baseline-shift="super" font-size="{number(substring-before($footnote.font.size,'pt'))-2}pt">
    <xsl:copy-of select="$mark"/>
  </fo:inline>
</xsl:template>







<!-- borderibg keycaps -->
<!--<xsl:template match="keycap">
<fo:inline padding="5pt" border-style="solid" font-family="monospace"><xsl:value-of select="."/></fo:inline>
</xsl:template>-->




<xsl:template match="glossentry/glossterm" mode="glossary.as.blocks">
  <fo:block space-before="5pt" keep-with-next.within-column="always" text-indent="0em"><fo:inline font-weight="bold"><xsl:apply-templates/></fo:inline></fo:block>
</xsl:template>


<xsl:template match="chapterinfo/revhistory" mode="chapter.titlepage.recto.auto.mode" priority="2"/>
<xsl:template match="sectioninfo/revhistory" mode="section.titlepage.recto.auto.mode" priority="2"/>
<xsl:template match="partinfo/revhistory" mode="part.titlepage.recto.auto.mode" priority="2"/>

<!--   -->
<xsl:template match="table">
  <xsl:variable name="id">
    <xsl:call-template name="object.id"/>
  </xsl:variable>
  <fo:float>
  <xsl:variable name="param.placement"
                select="substring-after(normalize-space($formal.title.placement),
                                        concat(local-name(.), ' '))"/>

  <xsl:variable name="placement">
    <xsl:choose>
      <xsl:when test="contains($param.placement, ' ')">
        <xsl:value-of select="substring-before($param.placement, ' ')"/>
      </xsl:when>
      <xsl:when test="$param.placement = ''">before</xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$param.placement"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name="prop-columns"
    select=".//colspec[contains(@colwidth, '*')]"/>

  <xsl:variable name="table.content">
    <fo:block id="{$id}"
              xsl:use-attribute-sets="formal.object.properties">

      <xsl:if test="$placement = 'before'">
        <xsl:call-template name="formal.object.heading">
          <xsl:with-param name="placement" select="$placement"/>
        </xsl:call-template>
      </xsl:if>

      <fo:table border-collapse="collapse">
        <xsl:call-template name="table.frame"/>
        <xsl:if test="count($prop-columns) != 0">
          <xsl:attribute name="table-layout">fixed</xsl:attribute>
        </xsl:if>
        <xsl:apply-templates select="tgroup"/>
      </fo:table>

      <xsl:if test="$placement != 'before'">
        <xsl:call-template name="formal.object.heading">
          <xsl:with-param name="placement" select="$placement"/>
        </xsl:call-template>
      </xsl:if>
    </fo:block>
  </xsl:variable>

  <xsl:variable name="footnotes">
    <xsl:if test="tgroup//footnote">
      <fo:block font-family="{$body.font.family}"
                font-size="{$footnote.font.size}"
                keep-with-previous="always">
        <xsl:apply-templates select="tgroup//footnote" mode="table.footnote.mode"/>
      </fo:block>
    </xsl:if>
  </xsl:variable>

  <xsl:choose>
    <xsl:when test="@orient='land'">
      <fo:block-container reference-orientation="90">
        <fo:block>
          <xsl:attribute name="span">
            <xsl:choose>
              <xsl:when test="@pgwide=1">all</xsl:when>
              <xsl:otherwise>none</xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <xsl:copy-of select="$table.content"/>
          <xsl:copy-of select="$footnotes"/>
        </fo:block>
      </fo:block-container>
    </xsl:when>
    <xsl:otherwise>
      <fo:block>
        <xsl:attribute name="span">
          <xsl:choose>
            <xsl:when test="@pgwide=1">all</xsl:when>
            <xsl:otherwise>none</xsl:otherwise>
          </xsl:choose>
        </xsl:attribute>
        <xsl:copy-of select="$table.content"/>
        <xsl:copy-of select="$footnotes"/>
      </fo:block>
    </xsl:otherwise>
  </xsl:choose>
  </fo:float>
</xsl:template>


<xsl:template match="para" mode="xref-to">
  <xsl:param name="referrer"/>
  <xsl:param name="xrefstyle"/>

  <xsl:apply-templates select="." mode="object.xref.markup">
    <xsl:with-param name="purpose" select="'xref'"/>
    <xsl:with-param name="xrefstyle" select="$xrefstyle"/>
    <xsl:with-param name="referrer" select="$referrer"/>
  </xsl:apply-templates>

</xsl:template>


<!-- ==================================================================== -->
<!-- Book templates -->

<!-- Note: these templates cannot use *.titlepage.recto.mode or
     *.titlepage.verso.mode. If they do then subsequent use of a custom
     titlepage.templates.xml file will not work correctly. -->

<!-- book recto -->

<xsl:template match="bookinfo/authorgroup" mode="titlepage.mode" priority="2">
  <fo:block hyphenate="false">
    <xsl:if test="@id">
      <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
    </xsl:if>
    <xsl:call-template name="gentext">
      <xsl:with-param name="key" select="'by'"/>
    </xsl:call-template>
    <xsl:text> </xsl:text>
    <xsl:call-template name="person.name.list"/>
  </fo:block>
</xsl:template>

<!-- book verso -->

<xsl:template name="book.verso.title">
  <fo:block hyphenate="false">
    <xsl:apply-templates mode="titlepage.mode"/>

    <xsl:if test="following-sibling::subtitle
                  |following-sibling::bookinfo/subtitle">
      <xsl:text>: </xsl:text>

      <xsl:apply-templates select="(following-sibling::subtitle
                                   |following-sibling::bookinfo/subtitle)[1]"
                           mode="book.verso.subtitle.mode"/>
    </xsl:if>
  </fo:block>
</xsl:template>



<xsl:template name="collect-authors-container">
  <!-- FIXME: possible keep-with-next needed -->
    <!-- FIXME: works for book only -->
  <xsl:if test="not(contains(local-name(..),'section'))">
  <fo:block hyphenate="false" font-size="12pt" space-before="2em">
    <xsl:call-template name="collect-authors"/>
  </fo:block>
  </xsl:if>
</xsl:template>

<xsl:template name="component.separator">
</xsl:template>

</xsl:stylesheet>
