<?xml version="1.0" encoding='koi8-r'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                              xmlns:fo="http://www.w3.org/1999/XSL/Format" 
                              xmlns:exsl="http://exslt.org/common">

<!--   -->
<xsl:template name="header.table">
  <xsl:param name="pageclass" select="''"/>
  <xsl:param name="sequence" select="''"/>
  <xsl:param name="gentext-key" select="''"/>
  <xsl:variable name="colontitle.font.size" select="concat(string($body.font.master - 1),'pt')"/>
  <xsl:variable name="candidate">
    <xsl:call-template name="head.sep.rule"/>
    <xsl:choose>
      <xsl:when test="$sequence='even' and $pageclass !='titlepage'">
        <fo:table table-layout="fixed" width="100%">
          <fo:table-column column-number="1" column-width="10%"/>
          <fo:table-column column-number="2" column-width="90%"/>
          <fo:table-body>
            <fo:table-row height="10pt">
              <fo:table-cell text-align="left" relative-align="baseline" display-align="before">
                <fo:block font-size="{$colontitle.font.size}">
                  <fo:page-number/>
                </fo:block>
              </fo:table-cell>
              <fo:table-cell text-align="right" relative-align="baseline">
                <fo:block text-align="right" font-size="{$colontitle.font.size}">
                  <xsl:value-of select="/book/subtitle"/>
                </fo:block>
              </fo:table-cell>
            </fo:table-row>
          </fo:table-body>
        </fo:table>
      </xsl:when>
      <xsl:when test="$sequence='odd' and $pageclass !='titlepage'"> 
      <fo:table table-layout="fixed" width="100%">
        <fo:table-column column-number="1" column-width="90%"/>
        <fo:table-column column-number="2" column-width="10%"/>
        <fo:table-body>
          <fo:table-row height="10pt">
            <fo:table-cell text-align="left" relative-align="baseline" display-align="before">
              <fo:block wrap-option="no-wrap" font-size="{$colontitle.font.size}">
                <xsl:apply-templates select="." mode="object.title.markup"/>
              </fo:block>
            </fo:table-cell>
            <fo:table-cell text-align="right" relative-align="baseline">
              <fo:block text-align="right"  font-size="{$colontitle.font.size}">
                <fo:page-number/>
              </fo:block>
            </fo:table-cell>
          </fo:table-row>
        </fo:table-body>
      </fo:table>
    </xsl:when>
  </xsl:choose>
</xsl:variable>

<xsl:choose>
  <xsl:when test="$pageclass = 'titlepage' and $gentext-key = 'book' and $sequence='first'"/>
  <xsl:when test="$sequence = 'blank' and $headers.on.blank.pages = 0"/>
  <xsl:otherwise>
    <xsl:copy-of select="$candidate"/>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="footer.table"/>

</xsl:stylesheet>
